﻿namespace ProjectTank.Drawning;

public class DrawningTankCompareByColor : IComparer<DrawningTank?>
{
    public int Compare(DrawningTank? x, DrawningTank? y)
    {
        if (x == null && y == null) return 0;
        if (x == null || x.EntityTank == null)
        {
            return 1;
        }

        if (y == null || y.EntityTank== null)
        {
            return -1;
        }

        if (ToHex(x.EntityTank.BodyColor) != ToHex(y.EntityTank.BodyColor))
        {
            return String.Compare(ToHex(x.EntityTank.BodyColor), ToHex(y.EntityTank.BodyColor),
                StringComparison.Ordinal);
        }

        var speedCompare = x.EntityTank.Speed.CompareTo(y.EntityTank.Speed);
        if (speedCompare != 0)
        {
            return speedCompare;
        }

        return x.EntityTank.Weight.CompareTo(y.EntityTank.Weight);
    }
    static String ToHex(Color c)
           => $"#{c.R:X2}{c.G:X2}{c.B:X2}";

}