﻿
using ProjectTank.Drawning;

namespace ProjectTank.Drawnings;
/// <summary>
/// Сравнение по типу, скорости и весу
/// </summary>
public class DrawningTankCompareByType : IComparer<DrawningTank?>
{
    public int Compare(DrawningTank? x, DrawningTank? y)
    {
        if (x == null || x.EntityTank == null)
        {
            return -1;
        }
        if (y == null || y.EntityTank == null)
        {
            return 1;
        }
        if (x.GetType().Name != y.GetType().Name)
        {
            return x.GetType().Name.CompareTo(y.GetType().Name);
        }

        var speedCompare = x.EntityTank.Speed.CompareTo(y.EntityTank.Speed);
        if (speedCompare != 0)
        {
            return speedCompare;
        }

        return x.EntityTank.Weight.CompareTo(y.EntityTank.Weight);
    }
}