﻿
using ProjectTank.Drawning;
using System.Diagnostics.CodeAnalysis;
namespace ProjectTank.Drawnings;

public class DrawningTankEqutables : IEqualityComparer<DrawningTank?>
{
    public bool Equals(DrawningTank? x, DrawningTank? y)
    {
        if (x == null || x.EntityTank == null)
        {
            return false;
        }
        if (y == null || y.EntityTank == null)
        {
            return false;
        }
        if (x.GetType().Name != y.GetType().Name)
        {
            return false;
        }
        if (x.EntityTank.Speed != y.EntityTank.Speed)
        {
            return false;
        }
        if (x.EntityTank.Weight != y.EntityTank.Weight)
        {
            return false;
        }
        if (x.EntityTank.BodyColor != y.EntityTank.BodyColor)
        {
            return false;
        }
        if (x is DrawningBattleTank && y is DrawningBattleTank)
        {
            EntityBattleTank entityX = (EntityBattleTank)x.EntityTank;
            EntityBattleTank entityY = (EntityBattleTank)y.EntityTank;
            if (entityX.MachinGun!= entityY.MachinGun)
            {
                return false;
            }
            if (entityX.Gun != entityY.Gun)
            {
                return false;
            }
            if (entityX.AdditionalColor != entityY.AdditionalColor)
            {
                return false;
            }
        }
        return true;
    }

    public int GetHashCode([DisallowNull] DrawningTank? obj)
    {
        return obj.GetHashCode();
    }
}